import 'codable.dart';

class PagingQuery<T extends Encodable> implements Encodable {
  /// Default limit
  static const int DefaultLimit = 25;

  /// Max. number or returned entries.
  int limit = DefaultLimit;

  /// Cursor for pagination.
  String next = '';

  T? _query;

  ///
  /// Create paging query.
  ///
  /// [query] underlying query.
  ///
  PagingQuery(T? query) {
    this._query = query;
  }

  static PagingQuery simpleQuery() {
    PagingQuery query = PagingQuery(null);
    return query;
  }

  Map<String, dynamic> toJSON() => {
        'query': _query?.toJSON(),
        'limit': limit,
        'next': next,
      };
}
