import '../common/public.dart';
import '../common/codable.dart';

class ChatId extends Encodable {
  String? _id;
  UserId? _userId;

  ///
  /// Create a single ChatId instance.
  ///
  /// [id]    Chat Id.
  ///
  static ChatId create(String id) {
    ChatId instance = new ChatId();
    instance._id = id;
    return instance;
  }

  ///
  /// Create a new ChatId instance with user id.
  ///
  /// [userId]      User Id.
  ///
  static ChatId createWithUserId(UserId userId) {
    ChatId instance = new ChatId();
    instance._userId = userId;
    return instance;
  }

  Map<String, dynamic> toJSON() => {
    'id': _id,
    'userId': _userId?.toJSON(),
  };
}
