import '../common/codable.dart';
import '../common/media_attachment.dart';
import 'communitiesaction.dart';

/// Describe GroupContent object.
class GroupContent extends Encodable {
  late String id;
  String? title;
  String? description;
  Map<String, String> properties = {};
  bool isPrivate = false;
  bool isDiscoverable = false;
  MediaAttachment? avatar;
  Map<int, int> permissions = {};

  Map<String, dynamic> toJSON() => {
    'id': id,
    'title': title == null ? '' : title,
    'description': description == null ? '' : description,
    'isPrivate': isPrivate,
    'isDiscoverable': isDiscoverable,
    'avatar': avatar?.toJSON(),
    'properties': properties,
    'permissions': permissions.map((key, value) => MapEntry(CommunitiesAction.valueToName(key), value)),
  };
}
