import '../../common/codable.dart';
import 'chatmessagesquery.dart';

class ChatMessagesPagingQuery implements Encodable {
  late ChatMessagesQuery _query;

  /// Default limit
  static const int DefaultLimit = 20;

  /// Max. number or returned entries.
  int limit = DefaultLimit;

  /// Cursor for next page.
  String nextMessagesCursor = '';

  /// Cursor for next page.
  String previousMessagesCursor = '';

  ChatMessagesPagingQuery(ChatMessagesQuery query) {
    this._query = query;
  }

  Map<String, dynamic> toJSON() => {
    'limit': limit,
    'query': _query.toJSON(),
    'nextMessages': nextMessagesCursor,
    'previousMessages': previousMessagesCursor,
  };
}
