import '../../common/codable.dart';

class MembersQuery extends Encodable {
  late String groupId;
  int? role;
  int? status;

  MembersQuery(String groupId) {
    this.groupId = groupId;
  }

  static MembersQuery ofGroup(String groupId) {
    return MembersQuery(groupId);
  }

  MembersQuery withRole(int role) {
    this.role = role;
    return this;
  }

  MembersQuery withStatus(int status) {
    this.status = status;
    return this;
  }

  Map<String, dynamic> toJSON() => {
    'groupId': groupId,
    'role': role,
    'status': status
  };
}
