import '../../common/codable.dart';
import '../../common/public.dart';
import '../public.dart';

class UpdateGroupMembersQuery extends Encodable {
  late String groupId;
  late UserIdList userIdList;
  int role = Role.member;
  int status = MemberStatus.member;
  String? invitationToken;

  UpdateGroupMembersQuery(String groupId, UserIdList userIdList) {
    this.groupId = groupId;
    this.userIdList = userIdList;
  }

  static UpdateGroupMembersQuery create(String groupId, UserIdList userIdList) {
    return UpdateGroupMembersQuery(groupId, userIdList);
  }

  UpdateGroupMembersQuery withRole(int role) {
    this.role = role;
    return this;
  }

  UpdateGroupMembersQuery withMemberStatus(int memberStatus) {
    this.status = status;
    return this;
  }

  UpdateGroupMembersQuery withInvitationToken(String invitationToken) {
    this.invitationToken = invitationToken;
    return this;
  }

  Map<String, dynamic> toJSON() => {
    'groupId': groupId,
    'userIdList': userIdList.toJSON(),
    'role': role,
    'status': status,
    'invitationToken': invitationToken,
  };
}
