import '../../communities/chatmessage.dart';

/// Describe ChatMessagesPagingResult object.
class ChatMessagesPagingResult {
  ChatMessagesPagingResult.fromJSON(Map<String, dynamic> json) {
    if (json['entries'] != null) {
      var rawList = (json['entries'] as List<dynamic>);
      if (rawList.isNotEmpty) {
        entries = rawList.map((e) => ChatMessage.fromJSON(e)).toList();
      }
    }
    nextMessagesCursor = json['next'];
    previousMessagesCursor = json['previous'];
    refreshCursor = json['refreshCursor'];
  }

  /// Entries
  List<ChatMessage> entries = [];

  /// Cursor for pagination
  String nextMessagesCursor = '';
  String previousMessagesCursor = '';
  String refreshCursor = '';
}
