import '../common/codable.dart';

class NotificationBadge extends Encodable {
  int? increase;
  int? badge;

  /// Create NotificationBadge object, which will increase the badge number with the specified value.
  /// [increaseBy]  Increment value.
  static NotificationBadge increaseBy(int increaseBy) {
    var badge = NotificationBadge();
    badge.increase = increaseBy;
    return badge;
  }

  /// Create a notification badge object, which will set the badge number with the specified value.
  /// [badgeValue]  Badge value.
  static NotificationBadge setValue(int badgeValue) {
    var badge = NotificationBadge();
    badge.badge = badgeValue;
    return badge;
  }

  Map<String, dynamic> toJSON() => {
        'increase': increase == null ? null : increase,
        'badge': badge == null ? null : badge
      };

  @override
  String toString() {
    return 'NotificationBadge{'
        'increase: $increase, '
        'badge: $badge'
        '}';
  }
}
