import '../common/codable.dart';
import '../common/media_attachment.dart';
import '../common/action.dart';
import 'notificationbadge.dart';
import 'notificationbutton.dart';
import 'notificationcustomization.dart';

/// Describe NotificationContent object.
class NotificationContent extends Encodable {
  /// Text.
  String? text;

  /// Title.
  String? title;

  /// Template name.
  String? templateName;

  /// Action.
  GetSocialAction? action;

  /// Action buttons.
  List<NotificationButton> actionButtons = [];

  /// Media attachment.
  MediaAttachment? mediaAttachment;

  /// Template placeholders.
  Map<String, String> templatePlaceholders = {};

  /// Customization.
  NotificationCustomization? customization;

  /// Badge.
  NotificationBadge? badge;

  Map<String, dynamic> toJSON() => {
        'text': text == null ? null : text,
        'title': title == null ? null : title,
        'actionButtons': actionButtons.map((e) => e.toJSON()).toList(),
        'action': action?.toJSON(),
        'templateName': templateName,
        'templatePlaceholders':
            templatePlaceholders,
        'mediaAttachment':
            mediaAttachment?.toJSON(),
        'customization': customization?.toJSON(),
        'badge': badge?.toJSON()
      };
}
