import '../common/codable.dart';
import '../common/public.dart';

/// Describe placeholders for notification receivers.
class NotificationReceiverPlaceholder {
  /// Placeholder to send notification to all friends.
  static const String friends = 'friends';

  /// Placeholder to send notification to referred users.
  static const String referredUsers = 'referred_users';

  /// Placeholder to send notification to referrer.
  static const String referrer = 'referrer';
}

/// Notification target object.
class SendNotificationTarget extends Encodable {
  /// UserIds.
  UserIdList? userIdList;

  /// Placeholders, check NotificationReceiverPlaceholder for possible values.
  List<String> receiverPlaceholders = [];

  Map<String, dynamic> toJSON() => {
        'userIdList': userIdList == null
            ? UserIdList.create([]).toJSON()
            : userIdList?.toJSON(),
        'placeholderIds': receiverPlaceholders
      };
}
